<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class BlockCard extends \Zeedhi\Framework\Controller\Simple {

    protected $blockCardService;
    protected $profileService;
    protected $SMTPService;
    protected $snackMessage;
    protected $util;

    public function __construct(\Service\BlockCard $blockCardService, \Service\Profile $profileService, \Service\SMTP $SMTPService, \Util\SnackMessage $snackMessage, \Util\Util $util){
        $this->blockCardService = $blockCardService;
        $this->profileService = $profileService;
        $this->SMTPService = $SMTPService;
        $this->snackMessage = $snackMessage;
        $this->util = $util;
    }

    public function getCardStatus(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $CDCONSUMIDOR = $params[0]['value'];
            $CDCLIENTE    = $params[1]['value'];

            $status = $this->blockCardService->getCardStatus($CDCONSUMIDOR, $CDCLIENTE);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('CardStatusRepository', $status));

        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function toggleBlock(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();

            $IDSITCONSUMI = $params[0]['value'];
            $CDCLIENTE    = $params[1]['value'];
            $CDCONSUMIDOR = $params[2]['value'];

            $this->blockCardService->toggleBlock($IDSITCONSUMI, $CDCLIENTE, $CDCONSUMIDOR);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ToggleBlock', array(array())));

        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }
    }

}