<?php

namespace Service;

class Profile {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function getConsumerDetails($CDCLIENTE, $CDCONSUMIDOR){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CONSUMER_DETAILS, $params);
    }

    public function getState($search){
        $params = array(
            ':NMESTADO' => $search
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_STATES, $params);
    }

    public function getCities($SGESTADO, $NMMUNICIPIO, $FIRST, $LAST){
        $params = array(
            ':SGESTADO' => $SGESTADO,
            ':NMMUNICIPIO' => $NMMUNICIPIO,
            ':FIRST' => $FIRST,
            ':LAST' => $LAST
        );

        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CITIES, $params);
    }

    public function getNeighborhoods($CDPAIS, $SGESTADO, $CDMUNICIPIO, $FIRST, $LAST, $NMBAIRRO){
        $params = array(
            ':CDPAIS' => $CDPAIS,
            ':SGESTADO' => $SGESTADO,
            ':CDMUNICIPIO' => $CDMUNICIPIO,
            ':FIRST' => $FIRST,
            ':LAST' => $LAST,
            ':NMBAIRRO' => $NMBAIRRO
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_BAIRROS, $params);
    }

    public function saveConsumerFirstData($consumerDetail){
        $params = array();

        foreach ($consumerDetail as $column => $value){
            $params[':'.$column] = $value;
        }
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::SAVE_CONSUMER_FIRST_DATA, $params);
    }

    public function updateConsumerDetails($consumerDetail){
        $params = array();

        foreach ($consumerDetail as $column => $value){
            $params[':'.$column] = $value;
        }
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::UPDATE_CONSUMER_DETAILS, $params);
    }

    public function getPassword($CDCLIENTE, $NMLOGINCONS){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':NMLOGINCONS' => $NMLOGINCONS
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PASSWORD, $params);
        return !Empty($result) ? $result[0]['CDSENHACONSMD5'] : $result;
    }

    public function changePassword($newPassword, $CDCLIENTE, $NMLOGINCONS){
        $params = array(
            ':CDSENHACONSMD5' => $newPassword,
            ':CDCLIENTE' => $CDCLIENTE,
            ':NMLOGINCONS' => $NMLOGINCONS
        );
        $this->entityManager->getConnection()->executeQuery(\Util\Query::SQL_CHANGE_PASSWORD, $params);
    }

    public function getFilialPais($CDFILIAL){
        $params = array(
            ':CDFILIAL' => $CDFILIAL
        );
        $retorno = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_FILIAL_ENDE, $params);
        return $retorno[0]['CDPAIS'];
    }

    public function getPermissionRestrictAliment($CDFILIAL, $CDTIPOCONS){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDTIPOCONS' => $CDTIPOCONS
        );
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_TIPOCONSFILI_RESALIM, $params);
    }

    public function getLowBalanceConsumers(){
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::LOW_GROUPED_BALANCES, array());
    }

    public function getSonsNotifValByParent($CDCLIENTE, $NRCPFRESPCON){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':NRCPFRESPCON' => $NRCPFRESPCON
        );
        return $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_SONS_NOTIF_VAL, $params);
    }

    public function updateSonNotifVal($CDCONSUMIDOR, $VRNOTIFSALDO, $CDCLIENTE){
        $params = array(
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':VRNOTIFSALDO' => $VRNOTIFSALDO,
            ':CDCLIENTE' => $CDCLIENTE
        );
        return $this->entityManager->getConnection()->executeQuery(\Util\Query::UPDATE_SON_NOTIF_VAL, $params);
    }

    public function getSMTP(){
        return $this->entityManager->getConnection()->fetchAll(\Service\SMTP::GET_SMTP, array());
    }

}