<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\PagarMe\PaymentImpl;
$paymentPlatform = PaymentImpl::factory(
    "ak_test_5hIRTiZgq9kEeatTvLQeD0erFYeBrr"
);

use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyPlatform;
use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyTransaction;

use Zeedhi\PaymentPlatform\Address;
use Zeedhi\PaymentPlatform\Customer;
use Zeedhi\PaymentPlatform\CreditCard;
use Zeedhi\PaymentPlatform\Item;

class Order {

    private $paymentPlatform;

    public function __construct(NonInstantBuyPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }

    public function createOrder($value, CreditCard $creditCard, Customer $customer, $items){
        $transaction = new NonInstantBuyTransaction($value, '', $creditCard, $customer);
        $transaction->setItems($items);
        $nit = $this->paymentPlatform->nonInstantBuyTransaction($transaction);
        var_dump($nit);
        $order = $this->paymentPlatform->captureTransaction($nit['captureUrl'], $nit['paymentId']);
        var_dump($order);
    }
}

$address = new Address('Rua Matrix', '9999', 'Apto. 101', 'Rio Cotia', 'Cotia', 'sp', '06714360', 'br');

$customer = new Customer();
$customer->setId('#3311');
$customer->setName('Morpheus Fishburne');
$customer->setEmail('mopheus@nabucodonozor.com');
$customer->setDocument('30621143049');
$customer->setPhone('+5511999998888');
$customer->setAddress($address);

$items = array();

$item1 = new Item('r123', 'Red pill', 100, 1);
$item2 = new Item('b123', 'Blue pill', 100, 1);

array_push($items, $item1);
array_push($items, $item2);

$creditCard = new CreditCard($customer->getName(), '4111111111111111', '09', '22', '123', 'Visa');

$value = 200;

$order = new Order($paymentPlatform);
$transactionKey = $order->createOrder($value, $creditCard, $customer, $items);