<?php 
namespace Zeedhi\PaymentPlatform\BankSlip;

use  Zeedhi\PaymentPlatform\Customer;

class BankSlipTransactionTest extends \PHPUnit_Framework_TestCase {
    
    /** @var BankSlipTransaction */
    protected $bankSlipTransaction;
    /** @var String */
    protected $bank = "itau";
    /** @var String */
    protected $value = "100.00";
    /** @var String */
    protected $documentNumber = "000001";
    /** @var String */
    protected $transactionId = "00000001";
    /** @var String */
    protected $instructions = "Boleto de testes Teknisa";
    /** @var String */
    protected $daysToAddInBankSlipExpirationDate = "5";
    /** @var Customer */
    protected $customer;
    
    public function setUp(){
        $this->customer =  $this->getMockBuilder(Customer::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();
                            
        $this->bankSlipTransaction = new BankSlipTransaction($this->bank, $this->value, $this->documentNumber, $this->transactionId, $this->instructions, $this->daysToAddInBankSlipExpirationDate, $this->customer);
    }
    
    public function testGetBank(){
        $this->assertEquals($this->bank, $this->bankSlipTransaction->getBank());
    }
    
    public function testGetValue(){
        $this->assertEquals($this->value, $this->bankSlipTransaction->getValue());
    }
    
    public function testGetDocumentNumber(){
        $this->assertEquals($this->documentNumber, $this->bankSlipTransaction->getDocumentNumber());
    }
    
    public function testGetTransactionId(){
        $this->assertEquals($this->transactionId, $this->bankSlipTransaction->getTransactionId());
    }
    
    public function testGetInstructions(){
        $this->assertEquals($this->instructions, $this->bankSlipTransaction->getInstructions());
    }
    
    public function testGetDaysToAddInBankSlipExpirationDate(){
        $this->assertEquals($this->daysToAddInBankSlipExpirationDate, $this->bankSlipTransaction->getDaysToAddInBankSlipExpirationDate());
    }
    
    public function testGetCustomer(){
        $this->assertEquals($this->customer, $this->bankSlipTransaction->getCustomer());
    }
    
}