<?php
namespace Zeedhi\PaymentPlatform\BilletBuy;

use Zeedhi\PaymentPlatform\Transaction;
use Zeedhi\PaymentPlatform\CreditCard;
use Zeedhi\PaymentPlatform\Customer;

class BilletBuyTransaction extends Transaction {

    /** @var CreditCard */
    private $creditCard;
    /** @var Customer */
    private $customer;
    
    /**
     * @param float         $value
     * @param string        $transactionId
     * @param CreditCard    $creditCard
     * @param Customer      $customer
     */
    public function __construct($value, $transactionId, Customer $customer, $nrInstallment = 1) {
        parent::__construct($value, $transactionId, $nrInstallment);
        $this->customer = $customer;
    }
    
    /**
     * @return Customer
     */
    public function getCustomer() {
        return $this->customer;
    }

    public function setItems($items) {
        $this->items = $items;
    }

    /**
     * @return Items
     */
    public function getItems() {
        return $this->items;
    }

    public function setTransactionType($TransactionType) {
        $this->TransactionType = $TransactionType;
    }

    /**
     * @return TransactionType
     */
    public function getTransactionType() {
        return $this->TransactionType;
    }

    public function setCredentialsAgency($CredentialsAgency) {
        $this->CredentialsAgency = $CredentialsAgency;
    }

    /**
     * @return CredentialsAgency
     */
    public function getCredentialsAgency() {
        return $this->CredentialsAgency;
    }

    public function setCredentialsAccount($CredentialsAccount) {
        $this->CredentialsAccount = $CredentialsAccount;
    }

    /**
     * @return CredentialsAccount
     */
    public function getCredentialsAccount() {
        return $this->CredentialsAccount;
    }

    public function setCredentialsCode($CredentialsCode) {
        $this->CredentialsCode = $CredentialsCode;
    }

    /**
     * @return CredentialsCode
     */
    public function getCredentialsCode() {
        return $this->CredentialsCode;
    }

    public function setCredentialsAgreement($CredentialsAgreement) {
        $this->CredentialsAgreement = $CredentialsAgreement;
    }

    /**
     * @return CredentialsAgreement
     */
    public function getCredentialsAgreement() {
        return $this->CredentialsAgreement;
    }

    public function setProvider($Provider) {
        $this->Provider = $Provider;
    }

    /**
     * @return Provider
     */
    public function getProvider() {
        return $this->Provider;
    }

}