function RechargeWizardController(ZHPromise, ScreenService, templateManager, RechargeValueRepository, Query, RechargeService, BuscaBandeirasesitefRepo) {

    /* Checks if there is something to recharge. If there is no value was entered, we have to stop the wizard from advancing. */
    this.checkValue = function(e){
        var rechargeValues = templateManager.container.getWidget('rechargeGrid').dataSource.data;
        var chargeValue = 0;

        var hasValue = rechargeValues.some(function (recharge){
            if (recharge.VRSALDCONFAM){
                if (recharge.VRSALDCONFAM.indexOf(',') == 1){
                    chargeValue = recharge.VRSALDCONFAM.replace(',','.');
                }
                else {
                    chargeValue = recharge.VRSALDCONFAM;
                }
                return parseFloat(chargeValue) > 0;
            }
        });

        if (!hasValue){
            ScreenService.showMessage('O valor total das recargas tem que ser maior que R$ 0,00.');
            e.preventDefault();
        }
    };

    /* Stores the recharge values in a repository to be used later. */
    this.storeRechargeValue = function(){
        var rechargeGrid = templateManager.container.widgets[0].dataSource.data;
        var rechargeValues = [];
        /*Grouping up values and clients using PARENT and PRIMARY properties*/
        var rechargeIndex = 0;
        rechargeGrid.forEach(function(object, index, array){
            if(object.VRSALDCONFAM !== null){
                rechargeGrid.forEach(function(_object, index, array){
                    if(object.PARENT == _object.PRIMARY){
                        if(object.VRSALDCONFAM != "0,00"){
                            valueConsumer = {CDCONSUMIDOR: _object.CDCONSUMIDOR , CDFAMILISALD: object.CDFAMILISALD, NMCONSUMIDOR: _object.NMCONSUMIDOR, VRSALDCONFAM: object.VRSALDCONFAM};
                            rechargeValues.push(valueConsumer);
                        }
                    }
                });
            }
        });
        //----
        RechargeValueRepository.remove(Query.build()).then(function (){
            RechargeValueRepository.save(rechargeValues);
        }.bind(this));
        return 'choosePayment';
    };
    /* Checks if the payment type was selected */
    this.checkPaymentType = function(e){

        var selectedPayment = templateManager.container.widgets[0].currentRow['selectedPayment'];

        if (selectedPayment !== 'creditCard' && selectedPayment !== 'billet'){
            ScreenService.showMessage('Selecione uma forma de pagamento para prosseguir.')
            e.preventDefault();
        }
    }
    /* Saves the type of payment in a repository. */
    this.storePaymentType = function(){

        var selectedPayment = templateManager.container.widgets[0].currentRow['selectedPayment'];

        var rota = '';
        if (selectedPayment == 'creditCard'){
            rota = 'creditCard';
        }
        else if (selectedPayment == 'billet'){
            rota = 'billet';
        }

        return rota;
    };

    this.preparePaymentType = function(paymentWidget){
        delete paymentWidget.dataSource.data;
        paymentWidget.newRow();

        RechargeService.getBankData().then(function (paymentDetails){

            var paymentTypes = [];
            if (paymentDetails['EsitefRepository'].length > 0)
                paymentTypes.push(
                    {
                        "DESC" : "Cartão de Crédito",
                        "VALUE": "creditCard"
                    }
                );

            if (paymentDetails['BankDataRepository'].length > 0) {
                paymentTypes.push(
                    {
                        "DESC" : "Boleto Bancário",
                        "VALUE": "billet"
                    }
                );
            }

            paymentWidget.getField('selectedPayment').dataSource.data = paymentTypes;
            templateManager.updateTemplate();
        });
    };

    /* Clears recharge values and cancels. */
    this.cancelRecharge = function() {
        RechargeValueRepository.remove(Query.build()).then(function (){
            ScreenService.openWindow('parentDashboard');
        });
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('RechargeWizardController', RechargeWizardController);
});